//
//  Network.h
//  UI18_AFN二次封装
//
//  Created by dllo on 15/8/31.
//  Copyright (c) 2015年 2015年 . All rights reserved.
//

#import <Foundation/Foundation.h>
@interface Network : NSObject

/**
 * @brief GET网络请求
 *
 * @param url 请求网址
 * @param dic 拼接的body
 * @param block 返回请求结果
 */
+ (void)networkGETRequesWithURL:(NSString *)url
                      Paramater:(NSDictionary *)dic
       pageUniquenessIdentifier:(NSString *)pageUniquenessIdentifier
                         result:(void (^)(id result))block;
/**
 * @brief POST网络请求
 * 
 * @param url 请求网址
 * @param body 拼接的body
 * @param block 返回请求结果
 */
+ (void)networkPOSTRequestWithURL:(NSString *)url
                             body:(NSString *)body
       pageUniquenessIdentifier:(NSString *)pageUniquenessIdentifier
                           result:(void(^)(id result))block;
/**
 * @brief POST网络请求 代送专用请求
 *
 * @param url 请求网址
 * @param body 拼接的body
 * @param block 返回请求结果
 */
+ (void)networkPOSTRequestForTaskFromShopWithURL:(NSString *)url
                             body:(NSString *)body
         pageUniquenessIdentifier:(NSString *)pageUniquenessIdentifier
                           result:(void(^)(id result))block;
/**
 * @brief 判断网络状态
 *
 * @return YES 有网 NO 无网
 */
+ (BOOL)isNetworkConnectionAvailable;




/** 获取当前时间 */
+ (NSString *)getCurrentTime:(BOOL)style;
/** 格式化时间 */
+ (NSString *)format:(NSString *)string;
/** 时间输出 */
+ (NSString *)compareDate:(NSDate *)date;
/** 字符串转化date */
+ (NSDate *)dateFromString:(NSString *)dateString;

@end
