 //
//  Network.m
//  UI18_AFN二次封装
//
//  Created by dllo on 15/8/31.
//  Copyright (c) 2015年 2015年 . All rights reserved.
//

#import "Network.h"
#import "Reachability.h"
#import "AFNetworking.h"
//#import "HUDManager.h"

@implementation Network

+ (void)networkGETRequesWithURL:(NSString *)url
                       Paramater:(NSDictionary *)dic
       pageUniquenessIdentifier:(NSString *)pageUniquenessIdentifier
                          result:(void (^)(id))block
{
    // 转码
    url = [url stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding];
    
    /* 开始缓存 */
    // 获取Caches路径
    NSString *cachesPath = [NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES)firstObject];
    
    /*创建缓存文件*/
    NSString *LCCachesFolderName = [NSString stringWithFormat:@"%@/LDYCaches",cachesPath];
//    NSLog(@"%@", LCCachesFolderName);
    NSFileManager *filemanger = [NSFileManager defaultManager];
    BOOL isDirectory = NO;
    BOOL existed = [filemanger fileExistsAtPath:LCCachesFolderName isDirectory:&isDirectory];
    if (!(isDirectory == YES && existed == YES)) {
        [filemanger createDirectoryAtPath:LCCachesFolderName withIntermediateDirectories:YES attributes:nil error:nil];
    }
    /* 缓存文件名*/
    NSString *cachesFileString = [NSString stringWithFormat:@"resultDataCacheFile_%@.plist",pageUniquenessIdentifier];
    
    /* 拼接路径 */
    NSString *cacheExistPath = [LCCachesFolderName stringByAppendingFormat:@"/%@",cachesFileString];
//    NSLog(@"Caches: %@",cacheExistPath);
    /* 缓存创建文件名结束 */
    
    // 判断是否有网
    if ([self isNetworkConnectionAvailable]) {
        // 创建请求对象
        AFHTTPRequestOperationManager *manager = [AFHTTPRequestOperationManager manager];
        // 请求HTTPS(若不添加, 无法解析HTTPS)
        manager.securityPolicy.allowInvalidCertificates = YES;
        // 设置请求格式
        manager.requestSerializer = [AFHTTPRequestSerializer serializer];
        // 响应格式
        manager.responseSerializer = [AFHTTPResponseSerializer serializer];
        // 设置响应的类型
        [manager.responseSerializer setAcceptableContentTypes:[NSSet setWithObjects:@"application/json", @"text/json", @"text/javascript", @"text/html", @"text/css", nil]];
        
        [manager.requestSerializer setValue:@"application/json; application/x-javascript;charset=utf-8" forHTTPHeaderField:@"Content-Type"];
        
        // 加载指示器
//        [HUDManager showStatusWithString:@"加载中..."];
        
        // GET请求
        /**
         * 参数1: url
         * 参数2: 拼接的body
         * 参数3: 成功块
         * 参数4: 失败块
         */
        [manager GET:url parameters:dic success:^(AFHTTPRequestOperation *operation, id responseObject) {
            // 转成JSON
            // operation.responseObject请求回的数据(请求回来的真正二进制文件)
            id result = [NSJSONSerialization JSONObjectWithData:operation.responseObject options:NSJSONReadingMutableContainers error:nil];
//            [HUDManager dismissHUD];
            
            /* 开始缓存 */
            [NSKeyedArchiver archiveRootObject:result toFile:cacheExistPath];
            /* 开始缓存 */
            
            block(result);
//            [HUDManager closeHUD];
        } failure:^(AFHTTPRequestOperation *operation, NSError *error) {
            // 输出错误信息
//            NSLog(@"%@", error);
        }];
        
    } else {
        
        /*  判断有网没网进行数据的缓存和缓存后的数据读取工作 */
        NSDictionary *takeOutCachesDataDic = [NSKeyedUnarchiver unarchiveObjectWithFile:cacheExistPath];
        if (takeOutCachesDataDic) {
            
            NSLog(@"无网 ----- 有缓存数据");
            block(takeOutCachesDataDic);
        }else
        {
            NSLog(@"无网 ----- 无缓存数据");
            /* 进行提示 */
            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"提示" message:@"无网络连接" delegate:self cancelButtonTitle:@"确定" otherButtonTitles:nil, nil];
            [alert show];
            
        }
//        [HUDManager closeHUD];
    }
    
}

+ (void)networkPOSTRequestWithURL:(NSString *)url
                             body:(NSString *)body
         pageUniquenessIdentifier:(NSString *)pageUniquenessIdentifier
                           result:(void(^)(id result))block
{
    
    // 转码
    url = [url stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding];
    
//    /* 开始缓存 */
//    // 获取Caches路径
//    NSString *cachesPath = [NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES)firstObject];
//
//    /*创建缓存文件*/
//    NSString *LCCachesFolderName = [NSString stringWithFormat:@"%@/LCCaches",cachesPath];
//    //    NSLog(@"%@", LCCachesFolderName);
//    NSFileManager *filemanger = [NSFileManager defaultManager];
//    BOOL isDirectory = NO;
//    BOOL existed = [filemanger fileExistsAtPath:LCCachesFolderName isDirectory:&isDirectory];
//    if (!(isDirectory == YES && existed == YES)) {
//        [filemanger createDirectoryAtPath:LCCachesFolderName withIntermediateDirectories:YES attributes:nil error:nil];
//    }
//    /* 缓存文件名*/
//    NSString *cachesFileString = [NSString stringWithFormat:@"resultDataCacheFile_%@.plist",pageUniquenessIdentifier];
//
//    /* 拼接路径 */
//    NSString *cacheExistPath = [LCCachesFolderName stringByAppendingFormat:@"/%@",cachesFileString];
//    //    NSLog(@"Caches: %@",cacheExistPath);
//    /* 缓存创建文件名结束 */
//
    if ([self isNetworkConnectionAvailable]) {
        AFHTTPRequestOperationManager *manager = [AFHTTPRequestOperationManager manager];
        manager.securityPolicy.allowInvalidCertificates = YES;
        manager.requestSerializer = [AFJSONRequestSerializer serializer];
        manager.responseSerializer = [AFHTTPResponseSerializer serializer];
        [manager.responseSerializer setAcceptableContentTypes:[NSSet setWithObjects:@"application/x-www-form-urlencoded",@"application/json", @"text/json", @"text/javascript", @"text/html", @"text/css", @"text/plain", @"application/x-javascript",nil]];
        //        [HUDManager showStatusWithString:@"加载中...."];
        
        NSArray *bodyArr = [body componentsSeparatedByString:@"&"];
        NSMutableDictionary *bodyDic = [NSMutableDictionary dictionary];
        for (NSString *string in bodyArr) {
            NSArray *tempArr = [string componentsSeparatedByString:@"="];
            [bodyDic setObject:tempArr[1] forKey:tempArr[0]];
        }
        
        [manager POST:url parameters:bodyDic success:^(AFHTTPRequestOperation *operation, id responseObject) {
            //            NSLog(@"%@", responseObject);
            
            id result = [NSJSONSerialization JSONObjectWithData:operation.responseObject options:NSJSONReadingMutableContainers error:nil];
//            id result = responseObject;
            
            /* 开始缓存 */
//            [NSKeyedArchiver archiveRootObject:result toFile:cacheExistPath];
            /* 开始缓存 */
            
            //            [HUDManager closeHUD];
            block(result);
        } failure:^(AFHTTPRequestOperation *operation, NSError *error) {
            NSLog(@"%@", error);
            NSMutableDictionary *result = [[NSMutableDictionary alloc]init];
            [result setValue:@"-1001" forKey:@"resultCode"];
            block(result);
            
        }];
    } else {
        
//        /*  判断有网没网进行数据的缓存和缓存后的数据读取工作 */
//        NSDictionary *takeOutCachesDataDic = [NSKeyedUnarchiver unarchiveObjectWithFile:cacheExistPath];
//        if (takeOutCachesDataDic) {
//
//            NSLog(@"无网 ----- 有缓存数据");
////            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"提示" message:@"无网络连接" delegate:self cancelButtonTitle:@"确定" otherButtonTitles:nil, nil];
////            [alert show];
////            block(takeOutCachesDataDic);
//        }else
//        {
//            NSLog(@"无网 ----- 无缓存数据");
//            /* 进行提示 */
//            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"提示" message:@"无网络连接" delegate:self cancelButtonTitle:@"确定" otherButtonTitles:nil, nil];
//            [alert show];
//
//        }
        //        [HUDManager closeHUD];
    }
}

+ (void)networkPOSTRequestForTaskFromShopWithURL:(NSString *)url
                             body:(NSString *)body
         pageUniquenessIdentifier:(NSString *)pageUniquenessIdentifier
                           result:(void(^)(id result))block
{
    
    // 转码
    url = [url stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding];
    
//    /* 开始缓存 */
//    // 获取Caches路径
//    NSString *cachesPath = [NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES)firstObject];
//
//    /*创建缓存文件*/
//    NSString *LCCachesFolderName = [NSString stringWithFormat:@"%@/LCCaches",cachesPath];
////    NSLog(@"%@", LCCachesFolderName);
//    NSFileManager *filemanger = [NSFileManager defaultManager];
//    BOOL isDirectory = NO;
//    BOOL existed = [filemanger fileExistsAtPath:LCCachesFolderName isDirectory:&isDirectory];
//    if (!(isDirectory == YES && existed == YES)) {
//        [filemanger createDirectoryAtPath:LCCachesFolderName withIntermediateDirectories:YES attributes:nil error:nil];
//    }
//    /* 缓存文件名*/
//    NSString *cachesFileString = [NSString stringWithFormat:@"resultDataCacheFile_%@.plist",pageUniquenessIdentifier];
//
//    /* 拼接路径 */
//    NSString *cacheExistPath = [LCCachesFolderName stringByAppendingFormat:@"/%@",cachesFileString];
////    NSLog(@"Caches: %@",cacheExistPath);
//    /* 缓存创建文件名结束 */
    
    if ([self isNetworkConnectionAvailable]) {
        AFHTTPRequestOperationManager *manager = [AFHTTPRequestOperationManager manager];
        manager.securityPolicy.allowInvalidCertificates = YES;
        manager.requestSerializer = [AFJSONRequestSerializer serializer];
        manager.responseSerializer = [AFHTTPResponseSerializer serializer];
        [manager.responseSerializer setAcceptableContentTypes:[NSSet setWithObjects:@"application/json", @"text/json", @"text/javascript", @"text/html", @"text/css", @"text/plain", @"application/x-javascript",nil]];
//        [HUDManager showStatusWithString:@"加载中...."];
        
        NSArray *bodyArr = [body componentsSeparatedByString:@"&"];
        NSMutableDictionary *bodyDic = [NSMutableDictionary dictionary];
        for (NSString *string in bodyArr) {
            // array=a:b#c:d#e:f,a:b#c:d#e:f
            if ([string rangeOfString:@"goodsId"].location != NSNotFound && [string rangeOfString:@"goodsName"].location != NSNotFound && [string rangeOfString:@"goodsCopies"].location != NSNotFound && [string rangeOfString:@"goodsPrice"].location != NSNotFound) {
                
                NSArray *tempArr = [string componentsSeparatedByString:@"="];//array = xxxxx
                
                NSArray *goodsArr = [tempArr[1] componentsSeparatedByString:@","];
                NSMutableArray *finalArr = [NSMutableArray arrayWithCapacity:10];//array对应的数组
                
                for (NSString *goodsStr in goodsArr) {//goodsStr = a:b#c:d#e:f
                    NSMutableDictionary *goodDic = [NSMutableDictionary dictionaryWithCapacity:4];
                    NSArray *propertyArr = [goodsStr componentsSeparatedByString:@"#"];//a:b c:d e:f
                    for (NSString *property in propertyArr) {//a:b
                        NSArray *wordArr = [property componentsSeparatedByString:@":"];
                        [goodDic setObject:wordArr[1] forKey:wordArr[0]];
                    }
                    
                    [finalArr addObject:goodDic];
                }
                [bodyDic setObject:finalArr forKey:tempArr[0]];
            } else {
                NSArray *tempArr = [string componentsSeparatedByString:@"="];
                [bodyDic setObject:tempArr[1] forKey:tempArr[0]];
            }
        }
        
        [manager POST:url parameters:bodyDic success:^(AFHTTPRequestOperation *operation, id responseObject) {
//            NSLog(@"%@", responseObject);
            
            id result = [NSJSONSerialization JSONObjectWithData:operation.responseObject options:NSJSONReadingMutableContainers error:nil];
            
            /* 开始缓存 */
//            [NSKeyedArchiver archiveRootObject:result toFile:cacheExistPath];
            /* 开始缓存 */
                                    
//            [HUDManager closeHUD];
            block(result);
        } failure:^(AFHTTPRequestOperation *operation, NSError *error) {
            NSLog(@"%@", error);
            NSMutableDictionary *result = [[NSMutableDictionary alloc]init];
            [result setValue:@"-1001" forKey:@"resultCode"];
            block(result);

        }];
    } else {
        
//        /*  判断有网没网进行数据的缓存和缓存后的数据读取工作 */
//        NSDictionary *takeOutCachesDataDic = [NSKeyedUnarchiver unarchiveObjectWithFile:cacheExistPath];
//        if (takeOutCachesDataDic) {
//
//            NSLog(@"无网 ----- 有缓存数据");
//            block(takeOutCachesDataDic);
//        }else
//        {
//            NSLog(@"无网 ----- 无缓存数据");
//            /* 进行提示 */
//            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"提示" message:@"无网络连接" delegate:self cancelButtonTitle:@"确定" otherButtonTitles:nil, nil];
//            [alert show];
//
//        }
        //        [HUDManager closeHUD];
    }
}

+ (BOOL)isNetworkConnectionAvailable
{
    BOOL WithTheNetwork = YES;
    Reachability *reach = [Reachability reachabilityWithHostName:@"www.baidu.com"];
    switch ([reach currentReachabilityStatus]) {
        case NotReachable:
        {
            WithTheNetwork = NO;
            NSLog(@"无网络连接");
        }
            break;
        case ReachableViaWiFi:
        {
            WithTheNetwork = YES;
            NSLog(@"通过WiFi连接");
        }
            break;
        case ReachableViaWWAN:
        {
            WithTheNetwork = YES;
            NSLog(@"通过GPRS网络连接");
        }
            break;
        default:
            break;
    }
    return WithTheNetwork;
}




/** 格式化时间 */
+ (NSString *)format:(NSString *)string{
    NSDateFormatter *inputFormatter= [[NSDateFormatter alloc] init];
    [inputFormatter setLocale:[[NSLocale alloc] initWithLocaleIdentifier:@"en_US"] ];
    [inputFormatter setDateFormat:@"yyyy年MM月dd日 HH时mm分ss秒"];
    NSDate*inputDate = [inputFormatter dateFromString:string];
    //    NSLog(@"startDate= %@", inputDate);
    
    NSDateFormatter *outputFormatter= [[NSDateFormatter alloc] init];
    [outputFormatter setLocale:[NSLocale currentLocale]];
    [outputFormatter setDateFormat:@"yyyy-MM-dd HH:mm:ss"];
    //get date str
    NSString *str= [outputFormatter stringFromDate:inputDate];
    //str to nsdate
    NSDate *strDate = [outputFormatter dateFromString:str];
    NSDate *endDate = strDate;
    //修正8小时的差时
    //        NSTimeZone *zone = [NSTimeZone systemTimeZone];
    //        NSInteger interval = [zone secondsFromGMTForDate: strDate];
    //        NSDate *endDate = [strDate  dateByAddingTimeInterval: interval];
    //NSLog(@"endDate:%@",endDate);
    NSString *lastTime = [self compareDate:endDate];
    NSLog(@"lastTime = %@",lastTime);
    return str;
}
+ (NSString *)compareDate:(NSDate *)date{
    
    NSTimeInterval secondsPerDay = 24 * 60 * 60;
    //    NSLog(@"%@",date);
    //修正8小时之差
    NSDate *date1 = [NSDate date];
    NSTimeZone *zone = [NSTimeZone systemTimeZone];
    NSInteger interval = [zone secondsFromGMTForDate: date1];
    NSDate *localeDate = [date1  dateByAddingTimeInterval: interval];
    //
    //        NSLog(@"nowdate=%@\nolddate = %@",localeDate,date);
    NSDate *newDate = [date dateByAddingTimeInterval:8*60*60];
    NSDate *today = localeDate;
    NSDate *yesterday,*beforeOfYesterday;
    //今年
    NSString *toYears;
    
    toYears = [[today description] substringToIndex:4];
    
    yesterday = [today dateByAddingTimeInterval: -secondsPerDay];
    beforeOfYesterday = [yesterday dateByAddingTimeInterval: -secondsPerDay];
    
    // 10 first characters of description is the calendar date:
    NSString *todayString = [[today description] substringToIndex:10];
    NSString *yesterdayString = [[yesterday description] substringToIndex:10];
    NSString *beforeOfYesterdayString = [[beforeOfYesterday description] substringToIndex:10];
    
    NSString *dateString = [[newDate description] substringToIndex:10];
    NSString *dateYears = [[newDate description] substringToIndex:4];
    
    NSString *dateContent;
    if ([dateYears isEqualToString:toYears]) {//同一年
        //今 昨 前天的时间
        NSString *time = [[newDate description] substringWithRange:(NSRange){11,5}];
        //其他时间
        NSString *time2 = [[newDate description] substringWithRange:(NSRange){5,11}];
        if ([dateString isEqualToString:todayString]){
            dateContent = [NSString stringWithFormat:@"今天 %@",time];
            return dateContent;
        } else if ([dateString isEqualToString:yesterdayString]){
            dateContent = [NSString stringWithFormat:@"昨天 %@",time];
            return dateContent;
        }else if ([dateString isEqualToString:beforeOfYesterdayString]){
            dateContent = [NSString stringWithFormat:@"前天 %@",time];
            return dateContent;
        }else{
            return time2;
        }
    }else{
        return dateString;
    }
}

+ (NSString *)getCurrentTime:(BOOL)style
{
    NSDateFormatter *formatter = [NSDateFormatter new];
    [formatter setDateFormat:@"yyyy-MM-dd HH:mm:ss"];
    NSString *dateTime_format = [formatter stringFromDate:[NSDate date]];
    if (style) {
        return dateTime_format;
    }else{
        NSDate *dat = [NSDate dateWithTimeIntervalSinceNow:0];
        NSTimeInterval dateTime = [dat timeIntervalSince1970]*1000;
        NSString *dateTime_date = [NSString stringWithFormat:@"%.0f",dateTime];
        return dateTime_date;
    }
}




+ (NSDate *)dateFromString:(NSString *)dateString{
    
    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
    [dateFormatter setLocale:[NSLocale currentLocale]];
    [dateFormatter setDateFormat: @"yyyy-MM-dd HH:mm:ss"];
    
    NSDate *date= [dateFormatter dateFromString:dateString];
    return date;
    
}



@end
