//
//  VerificationController.m
//  ability_login_ios_demo_oc
//
//  Created by mac2022 on 2022/11/10.
//

#import "VerificationController.h"

@interface VerificationController ()

@property(nonatomic,copy) NSString *phoneTextStr;

@property(nonatomic,copy) NSString *phoneNumberCacheStr;

@property (copy, nonatomic) KLCodeResignView *codeView;

@end

@implementation VerificationController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
    _phoneTextStr = @"";
    
    NSUserDefaults *phoneDefaults = [NSUserDefaults standardUserDefaults];
    _phoneNumberCacheStr = [phoneDefaults objectForKey:@"phoneNumberCache"];
    if (_phoneNumberCacheStr.length>0) {
        _leftThreeLab.text = [_phoneNumberCacheStr substringToIndex:3];
        _rightFourLab.text = [_phoneNumberCacheStr substringFromIndex:7];
    }
   
    [self.view addSubview:self.codeView];
    
    __weak typeof(self) weakSelf = self;
    _codeView.codeResignCompleted = ^(NSString * _Nonnull content) {
        
        weakSelf.phoneTextStr = [NSString stringWithFormat:@"%@%@%@",weakSelf.leftThreeLab.text,content,weakSelf.rightFourLab.text];
        NSLog(@"完成 %@", weakSelf.phoneTextStr);
        [weakSelf clickVerificatMethod:[UIButton new]];
    };
   
    
    [self controlShowPhoneView];
}

-(KLCodeResignView *)codeView{
    if (!_codeView) {
        float safetop = UIApplication.sharedApplication.keyWindow.safeAreaInsets.top;
        float codeViewWidth = kscreenW-190;
        _codeView = [[KLCodeResignView alloc] initWithFrame:CGRectMake((kscreenW-codeViewWidth)/2, 257+safetop, codeViewWidth, 40)];
         _codeView.codeBits = 4;
         _codeView.codeResignUnCompleted = ^(NSString * _Nonnull content) {
             //NSLog(@"未完成 %@", content);
         };
    }
    return _codeView;
}

-(void)controlShowPhoneView{
    if(_phoneNumberCacheStr.length == 0){
        _leftThreeLab.hidden=YES;
        _codeView.hidden=YES;
        _rightFourLab.hidden=YES;
    }else{
        _phoneTextLab.hidden=YES;
        _phoneTextTxt.hidden=YES;
        _phoneTextLine.hidden=YES;
        _verificationButton.hidden=YES;
    }
}


-(void)touchesBegan:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event{
    [self.view endEditing:true];
}

- (IBAction)backMethod {
    [self dismissViewControllerAnimated:YES completion:nil];
}

- (IBAction)phoneTextMethod:(UITextField *)sender {
    _phoneTextStr = sender.text;
}


- (IBAction)clickVerificatMethod:(UIButton *)sender {
//    NSLog(@"点击了授权校验按钮  %@",_phoneTextStr);
    //    参数:accessCode,phone
    if (_phoneTextStr.length == 11) {
        [[AbilityLoginManage instance] verificationPhoneNumber:_phoneTextStr verificatTimeout:8 isCompletion:^(NSDictionary * _Nonnull result) {
            NSLog(@"44 result%@", result);
            if ([result[@"resultCode"] isEqualToString:@"0"]) {
                NSString *bodys = [NSString stringWithFormat:@"appId=%@&userId=%@&token=%@",appId,self->_veruserId,result[@"encrypt"]];
                ////客户服务器地址 
                NSString *urlStr = @"http://101.43.28.137:9300/appServer/verifyMobile";
                [Network networkPOSTRequestWithURL:urlStr body:bodys pageUniquenessIdentifier:bodys result:^(id result) {
                    NSLog(@"55 result%@", result);
                    NSLog(@"55 result%@", result[@"msg"]);
                    NSString *success = [NSString stringWithFormat:@"%@", [result objectForKey:@"code"]];
                    if ([success isEqualToString:@"200"]) {
                        if([result[@"data"][@"verifyMobile"] isEqual:@(0)]){
                            VerificationSucess *verificationSucessVC = [[VerificationSucess alloc] init];
                            verificationSucessVC.modalPresentationStyle = UIModalPresentationFullScreen;
                            [self presentViewController:verificationSucessVC animated:YES completion:nil];
                        }else {
                            VerificationFail *verificationFileVC = [[VerificationFail alloc] init];
                            verificationFileVC.failMsg = [ToolDemo dicToStr:result];
                            NSLog(@"---------- %@",[ToolDemo dicToStr:result]);
//                            verificationFileVC.failMsg = [NSString stringWithFormat:@"failMsg：%@",result[@"msg"]];
                            verificationFileVC.modalPresentationStyle = UIModalPresentationFullScreen;
                            [self presentViewController:verificationFileVC animated:YES completion:nil];
                        }
                    }else{
                        [WHToast showMessage:result[@"msg"] originY:self.view.frame.size.height-500.0 duration:1 finishHandler:nil];
                    }
                }];
                
            }else{
                [WHToast showMessage:result[@"resultMsg"] originY:self.view.frame.size.height-500.0 duration:1 finishHandler:nil];
            }
            
        }];
        
    }else{
        [WHToast showMessage:@"输入手机号的不正确" originY:self.view.frame.size.height-500.0 duration:1 finishHandler:nil];
    }
    
}





/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
