//
//  ViewController.m
//  ability_login_ios_demo_oc
//
//  Created by mac2022 on 2022/7/18.
//

#import "ViewController.h"
#import "Reachability.h"


@interface ViewController ()<abilityManageDelegate>

@property (copy,nonatomic) NSString *userId;

@property (assign,nonatomic) BOOL horizalScreen;

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.navigationController.navigationBarHidden = YES;
    [self initSDKV2];
    //这个是代理设置
    [AbilityLoginManage instance].delegate = self;
    
    [self setConstraint];
}

//1.0.3启用
- (void)initSDKV2 {
    [self cachePhoneNumber:@""];
    __weak typeof(self) weakSelf = self;
    [[AbilityLoginManage instance] initLogin:appId secret:appsecret isCompletion:^(NSDictionary * _Nonnull result) {
        NSString *success = [NSString stringWithFormat:@"%@", [result objectForKey:@"code"]];
        NSLog(@"initV2 %@",result);

        if (![success isEqualToString:@"200"]) {
            [weakSelf showInfos:result];
        }else{
            self.userId = result[@"userId"];
        }
    }];

}


- (IBAction)AllScreenLoginMethod:(UIButton *)sender {
    [ToolDemo borderButtonNormalStyle:sender];
    if (self.userId == nil) {
        [self showUserIdNilToast];
    }else{
        //预取号 返回数据
        __weak typeof(self) weakSelf = self;
        [[AbilityLoginManage instance] preLogin:8 isCompletion:^(NSDictionary * _Nonnull result) {
            NSLog(@"prelogin %@",result);
            if ([result[@"resultCode"] isEqualToString:@"0"]) {
                [weakSelf loginScreenMethod:30000];
            }else{
                [weakSelf showInfos:result];
            }
        }];
    }
    
}


- (IBAction)popScreenLoginMethod:(UIButton *)sender {
    [ToolDemo borderButtonNormalStyle:sender];
    if (self.userId == nil) {
        [self showUserIdNilToast];
    }else{
        __weak typeof(self) weakSelf = self;
        [[AbilityLoginManage instance] preLogin:8 isCompletion:^(NSDictionary * _Nonnull result) {
            NSLog(@"popPrelogin %@",result);
            if ([result[@"resultCode"] isEqualToString:@"0"]) {
                [weakSelf loginScreenMethod:30001];
            }else{
                [weakSelf showInfos:result];
            }
        }];
    }
}

- (IBAction)popBottomScreenLoginMethod:(UIButton *)sender {
    if(_horizalScreen){
        [WHToast showMessage:@"底部弹窗不支持横屏..." originY:self.view.frame.size.height-100.0 duration:1 finishHandler:nil];
    }else{
        [ToolDemo borderButtonNormalStyle:sender];
        if (self.userId == nil) {
            [self showUserIdNilToast];
        }else{
            __weak typeof(self) weakSelf = self;
            [[AbilityLoginManage instance] preLogin:8 isCompletion:^(NSDictionary * _Nonnull result) {
                NSLog(@"popPrelogin %@",result);
                if ([result[@"resultCode"] isEqualToString:@"0"]) {
                    [weakSelf loginScreenMethod:30002];
                }else{
                    [weakSelf showInfos:result];
                }
            }];
        }
    }
    
}



- (IBAction)verificationMethod:(UIButton *)sender {
    [ToolDemo solidButtonNormalStyle:sender];
    VerificationController *verificationVC = [[VerificationController alloc] init];
    verificationVC.veruserId = self.userId;
    verificationVC.modalPresentationStyle = UIModalPresentationFullScreen;
    [self presentViewController:verificationVC animated:YES completion:nil];
}



-(void)loginScreenMethod:(int)tag{
    ClickLogConfig *config = [[ClickLogConfig alloc] init];
    
    if (tag == 30000) {
        //授权登录页面全屏
        config.logIsPopup = false;
        config.isBottom = false;
        config.secondPOPUP = true;
        config.pruvacyOffsetY = 600;
    }else if(tag == 30001){
        //授权登录页面居中弹窗
        config.logIsPopup = true;
        config.isBottom = false;
        config.pruvacyOffsetY = 250;
    }else{
        //授权登录页面底部弹窗
        config.logIsPopup = true;
        config.isBottom = true;
        config.pruvacyOffsetY = 250;
    }
    
    //状态栏
    config.statusBarStyle = UIStatusBarStyleDefault;
    
    //授权页面
//    config.backgroundColor = [UIColor blueColor];
//    config.backgroundImage = [UIImage imageNamed:@"backImage.png"];
    
    //授权页导航栏
//    config.navBackColor = [UIColor redColor];
//    config.navText = @"导航栏文本123abc";
//    config.navTextSize = 22;
//    config.navTextColor = [UIColor yellowColor];
//    config.navFontBold = YES;
//    config.navIsHide = YES;
//    config.navTextStyle = @"AmericanTypewriter-Bold";
   
//    config.navReturnImg = [UIImage imageNamed:@"testcolse"];
//    config.navReturnOffsetX = 120;
//    config.navReturnOffsetY = 20;  //横
//    config.navReturnWidth = 20;
//    config.navReturnHeight = 10;
//    config.navReturnContentMode = 1;
//    config.navReturnHide = YES;
    
    //隐私协议导航栏
//    config.navPruvacyBackColor = [UIColor brownColor];
//    config.navPruvacyTextSize = 13;
//    config.navPruvacyTextColor = [UIColor grayColor];
//    config.navPruvacyReturnImg = [UIImage imageNamed:@"testclose1"];
    
    //LOGO
    /**LOGO图片*/
//    config.logoImg = [UIImage imageNamed:@"testlogin"];
//    config.logoOffsetX = 100;
//    config.logoOffsetY = 60;  //横
//    config.logoWidth = 100;
//    config.logoHeight = 100;
//    config.logoIsHiddle = YES;
//    config.logoContentMode = 1;
    
    //手机掩码
//    config.numberColor = [UIColor redColor];
//    config.numberTextSize = 20;
//    config.numberTextBold = true;
//    config.numFieldOffsetX = -50;
//    config.numFieldOffsetY = 150;  //横
//    config.numberTextStyle = @"AmericanTypewriter-Bold";
    
    //认证品牌
//    config.brandLabelTextSize = 12;
//    config.brandLabelTextColor = [UIColor redColor];
//    config.brandLabelOffsetX = 10;
//    config.brandLabelOffsetY = 190;  //横
//    config.brandFontBold = YES;
//    config.brandTextStyle = @"AmericanTypewriter-Bold";
//    config.brandTextArray = @[@"",@" ",@" "];
    
    //登录按钮
//    config.logBtnText = @"一键登录测试123abc";
//    config.logBtnTextSize = 20;
//    config.logBtnTextColor = [UIColor grayColor];
//    config.logBtnOriginL = 100;
//    config.logBtnOriginR = 100;
//    config.logBtnHeight = 44;
//    config.logBtnOffsetY = 225;  //横
//    config.logBtnImgs = @[
//        [UIImage imageNamed:@"testlogin"],
//        [UIImage imageNamed:@"testlogin"]
//    ];
//    config.logBtnFontBold = YES;
//    config.logBtnTextStyle = @"AmericanTypewriter-Bold";
    
    //其他登录按钮
//    config.otherWayLogBtnHidden = YES;
//    config.otherWayLogBtnText = @"其它登录方式-ABCD";
//    config.otherWayLogBtnTextColor = [UIColor blackColor];
//    config.otherWayLogBtnTextSize = 24;
//    config.otherWayLogBtnOffsetX = 10;
//    config.otherWayLogBtnOffsetY = 275;  //横
//    config.otherWayLogBtnOffWidth = 100;
//    config.otherWayLogBtnOffHeight = 20;
//    config.otherWayLogBtnTextStyle = @"AmericanTypewriter-Bold";
    
    //隐私协议
//    config.uncheckedImg = [UIImage imageNamed:@"untestselect"];
//    config.checkedImg = [UIImage imageNamed:@"testselect"];
//    config.checkedStatus = YES;
//    config.checkedWH = 34;
//    config.pruvacyOffsetL = 100;
//    config.pruvacyOffsetR = 100;
//    config.pruvacyOffsetY = 100;
//    config.pruvacyTextSize = 14;
//    config.norTruvacyTextColor = [UIColor grayColor];
//    config.pruTruvacyTextColor = [UIColor blueColor];

    config.defaultPruvacyPosition = FirstPosition;
    config.pruvacyBeforText = @"最前面的文字 ";
    config.pruvacyLinksText = @" 与";
    config.pruvacyAfterText = @" 最后面的文字dd";
    config.pruvacyBookMark = true;
//    config.pruvacyLineSpacing = 10;
//    config.pruvacyAlignment = NSTextAlignmentCenter;
//    config.pruvacyFontBold = YES;
//    config.pruvacyTextStyle = @"AmericanTypewriter";
    
    PruvacyTermItem *termItem1 = [[PruvacyTermItem alloc] initWithItemTitle:@"《自定义隐私一》" linkItemURL:[NSURL URLWithString:@"https://www.ctyun.cn/document/10022346"]];
    PruvacyTermItem *termItem2 = [[PruvacyTermItem alloc] initWithItemTitle:@"《自定义隐私二》" linkItemURL:[NSURL URLWithString:@"https://www.ctyun.cn/document/10022346/10026048"]];
    PruvacyTermItem *termItem3 = [[PruvacyTermItem alloc] initWithItemTitle:@"((自定义隐私三))" linkItemURL:[NSURL URLWithString:@"https://www.ctyun.cn/document/10022346/10026341"]];
    PruvacyTermItem *termItem4 = [[PruvacyTermItem alloc] initWithItemTitle:@" 自定义隐私四" linkItemURL:[NSURL URLWithString:@"https://www.ctyun.cn/document/10022346/10026363"]];
    config.pruvacyTitleAndUrlArr = @[termItem1,termItem2,termItem3,termItem4];
    
    
    //弹窗授权页
//    config.popupScaleW = 0.6;  //横
//    config.popupScaleH = 0.9;  //横
//    config.popupCornerRadius = 20;
//    config.popupAlpha = 0.3;
    
    
    
//    config.presentDismissDirection = 3;
    __block bool ispop = config.logIsPopup;
//    //自定义控件
    config.customUIHandler = ^(UIView * _Nonnull customAreaView) {
////        UILabel *customLab = [[UILabel alloc] init];
////        customLab.frame = CGRectMake(kscreenW/2+70, 285, 20, 30);
////        customLab.backgroundColor = [UIColor redColor];
////        customLab.hidden = ispop;
////        [customAreaView addSubview:customLab];
//
        UIButton *customBtn1 = [[UIButton alloc] initWithFrame:CGRectMake(kscreenW/4-30, 500, 60, 60)];
        customBtn1.layer.masksToBounds = YES;
        customBtn1.layer.cornerRadius = 30;
        customBtn1.tag = 1;
        [customBtn1 setImage:[UIImage imageNamed:@"weibo"] forState:UIControlStateNormal];
        [customBtn1 addTarget:self action:@selector(customBtn:) forControlEvents:UIControlEventTouchUpInside];
        customBtn1.hidden = ispop;
        [customAreaView addSubview:customBtn1];

        UIButton *customBtn2 = [[UIButton alloc] initWithFrame:CGRectMake(kscreenW/2-30, 500, 60, 60)];
        customBtn2.layer.masksToBounds = YES;
        customBtn2.layer.cornerRadius = 30;
        customBtn2.tag = 2;
        [customBtn2 setImage:[UIImage imageNamed:@"weixin"] forState:UIControlStateNormal];
        [customBtn2 addTarget:self action:@selector(customBtn:) forControlEvents:UIControlEventTouchUpInside];
        customBtn2.hidden = ispop;
        [customAreaView addSubview:customBtn2];

        UIButton *customBtn3 = [[UIButton alloc] initWithFrame:CGRectMake(kscreenW*3/4-30, 500, 60, 60)];
        customBtn3.layer.masksToBounds = YES;
        customBtn3.layer.cornerRadius = 30;
        customBtn3.tag = 3;
        [customBtn3 setImage:[UIImage imageNamed:@"pingguo"] forState:UIControlStateNormal];
        [customBtn3 addTarget:self action:@selector(customBtn:) forControlEvents:UIControlEventTouchUpInside];
        customBtn3.hidden = ispop;
        [customAreaView addSubview:customBtn3];
//
    };
    
    
        //授权登录成功 返回数据 
        __weak typeof(self) weakSelf = self;
        [[AbilityLoginManage instance] loginToken:self clickConfig:config getTokenTimeout:8 isCompletion:^(NSDictionary * _Nonnull result) {
            NSLog(@"login %@" ,result);
            
            NSString *code = result[@"resultCode"];
            if ([code isEqualToString:@"0"] ) {
                NSString *bodys = [NSString stringWithFormat:@"token=%@&userId=%@&appId=%@",result[@"encrypt"],self.userId,appId];
                //客户服务器地址
                NSString *urlStr = @"http://101.43.28.137:9300/appServer/getMobilePhoneProductionV2";
                [Network networkPOSTRequestWithURL:urlStr body:bodys pageUniquenessIdentifier:bodys result:^(id result) {
                    [[AbilityLoginManage instance] closeAuthViewController];
                    
                    NSLog(@"result%@", result);
                    [weakSelf showInfos:result];
                    NSString *success = [NSString stringWithFormat:@"%@", [result objectForKey:@"code"]];
                    if (![success isEqualToString:@"200"]) {
                        NSString *msg = [result objectForKey:@"msg"];
                        if (msg == nil || [msg isEqualToString:@""]) {
                            msg = @"请求超时";
                        }
                    }else{
                        NSDictionary *ourDic = [result objectForKey:@"data"];
                        NSString *encryptMobile = [NSString stringWithFormat:@"%@",[ourDic objectForKey:@"mobile"]];
                        NSLog(@"---%@", encryptMobile);
                        if (encryptMobile.length ==11) {
                            [weakSelf cachePhoneNumber:encryptMobile];
                        }
                        
                    }
                }];
    
            }
        }];
}



//登录按钮点击方法
-(void)abilityLogclick{
    NSLog(@"method: abilityLogclick");
    [WHToast showMessage:@"token loading..." originY:self.view.frame.size.height-100.0 duration:9 finishHandler:nil];
}

//其他方式的点击方法
-(void)otherLogclick{
    [[AbilityLoginManage instance] closeAuthViewController];
}

//点击关闭按钮
-(void)closeButtonClick{
    [[AbilityLoginManage instance] closeAuthViewController];
}

//隐私协议未选择,自定义toast
-(void)uncheckPrivacy{
    [WHToast showMessage:@"自定义-请同意服务条款" originY:self.view.frame.size.height-100.0 duration:1 finishHandler:nil];
}

//开启二次弹窗后，未勾选协议框时点击登录按钮的回调
-(void)secondPUPUPAbilityLogclick:(NSDictionary *)privacyAndUrl{
    NSLog(@"运营商默认隐私协议：%@",privacyAndUrl[@"title"]);
    NSLog(@"运营商默认隐私协议url：%@",privacyAndUrl[@"url"]);
    NSString *desc = @"未勾选协议，是否继续登陆？";
    UIAlertAction *okAction = [UIAlertAction actionWithTitle:@"确定" style:(UIAlertActionStyleDefault) handler:^(UIAlertAction * _Nonnull action) {
        [[AbilityLoginManage instance] secondPUPUPGetToken:YES];
    }];
    UIAlertAction *cancelAction = [UIAlertAction actionWithTitle:@"取消" style:(UIAlertActionStyleDefault) handler:^(UIAlertAction * _Nonnull action) {
        [[AbilityLoginManage instance] secondPUPUPGetToken:NO];
    }];
    UIAlertController *alert = [UIAlertController alertControllerWithTitle:@"提示" message:desc preferredStyle:(UIAlertControllerStyleAlert)];
    [alert addAction:okAction];
    [alert addAction:cancelAction];
    [self.presentedViewController presentViewController:alert animated:YES completion:nil];
}

//点击协议勾选框回调
-(void)privacyAgreementBoxStatus:(BOOL)boxStatuss{
    NSLog(@"-(void)privacyAgreementBoxStatus:(BOOL)boxStatuss");
    if (boxStatuss) {
        [WHToast showMessage:@"已勾选" originY:self.view.frame.size.height-100.0 duration:1 finishHandler:nil];
    }else{
        [WHToast showMessage:@"未勾选" originY:self.view.frame.size.height-100.0 duration:1 finishHandler:nil];
    }
    
}

//关闭授权页完成
-(void)closeAuthViewControllerCompleted{
    NSLog(@"关闭授权页完成");
    [WHToast hide];
}

-(void)customBtn:(UIButton *)button {
    switch (button.tag) {
        case 1:
            [WHToast showMessage:@"点击了自定义微博按钮" originY:self.view.frame.size.height-100.0 duration:1 finishHandler:nil];
            break;
        case 2:
            [WHToast showMessage:@"点击了自定义微信按钮" originY:self.view.frame.size.height-100.0 duration:1 finishHandler:nil];
            break;
        case 3:
            [WHToast showMessage:@"点击了自定义苹果按钮" originY:self.view.frame.size.height-100.0 duration:1 finishHandler:nil];
            break;
    }
    
}

/**
 转换显示资料
 */
- (NSString *)changeShowInfo:(id)sender {
    NSString *message = @"";
    for (id key in [sender allKeys]) {
        id value = sender[key];
        BOOL isDict = [value isKindOfClass:NSDictionary.class];
        
        message = isDict ? [message stringByAppendingFormat:@"\n%@ = %@",key, [self changeShowInfo:value]] : [message stringByAppendingFormat:@"\n%@ = \"%@\"",key,sender[key]];
    }
    
    return message;
}

- (void)showInfos:(NSDictionary *)sender {
    NSString *message = [self changeShowInfo:sender];

    // 1.创建UIAlertController
   UIAlertController *alertController = [UIAlertController alertControllerWithTitle:@"提示" message:[NSString stringWithFormat:@"%@",message] preferredStyle:UIAlertControllerStyleAlert];
    // 2.创建并添加按钮
    UIAlertAction *okAction = [UIAlertAction actionWithTitle:@"好的" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
        NSLog(@"OK Action");
    }];
    [alertController addAction:okAction];           // A
    UIViewController *rootview = [[[UIApplication sharedApplication] keyWindow] rootViewController];
    [rootview presentViewController:alertController animated:YES completion:nil];
}



- (IBAction)allScreenLoginDown:(UIButton *)sender {
    [ToolDemo borderButtonSelectStyle:sender];
}

- (IBAction)popScreenLoginDown:(UIButton *)sender {
    [ToolDemo borderButtonSelectStyle:sender];
}

- (IBAction)verificationDown:(UIButton *)sender {
    [ToolDemo solidButtonSelectStyle:sender];
}

- (void)setConstraint{
    if ([ToolDemo bangs_screen]) {
        self.logoTopConstraint.constant = 209.0;
        self.verifyBottomConstraint.constant = 187.0;
    }else{
        self.logoTopConstraint.constant = 129.0;
        self.verifyBottomConstraint.constant = 127.0;
    }
    
    //是否横屏
    if(kscreenW >= 667){
        _horizalScreen = YES;
//        _logoImage.hidden = YES;
        _titleLabel.hidden = YES;
        self.logoTopConstraint.constant = 5.0;
        self.verifyBottomConstraint.constant = 77.0;
    }
}

- (void)showUserIdNilToast{
    [WHToast showMessage:@"先初始化获取userid" originY:self.view.frame.size.height-500.0 duration:3 finishHandler:nil];
}

-(void)cachePhoneNumber:(NSString *)number{
    NSUserDefaults *phoneDefaults = [NSUserDefaults standardUserDefaults];
    [phoneDefaults setObject:number forKey:@"phoneNumberCache"];
    [phoneDefaults synchronize];
}

-(BOOL)shouldAutorotate{
    return NO;
}

-(UIInterfaceOrientationMask)supportedInterfaceOrientations{
    return UIInterfaceOrientationMaskPortrait;
}




@end
