//
//  ClickLogConfig.h
//  LXLogSDK
//
//  Created by 刘超 on 2021/12/6.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
NS_ASSUME_NONNULL_BEGIN

typedef NS_ENUM(NSUInteger,DefaultPruvacyPosition) {
    FirstPosition = 0,
    LastPosition
};

typedef NS_ENUM(NSUInteger,PresentDismissDirection) {
    BottomToUP = 0,
    RightToLeft,
    UPToBottom,
    LeftToRight
};

@interface ClickLogConfig : NSObject


/**
 版本注意事项：
 1.
 2.
 */

#pragma mark VC属性
/**授权登录页面是否是弹框 默认值no为全屏*/
@property (nonatomic, assign) BOOL logIsPopup;


#pragma mark 状态栏
/**状态栏样式*/
@property (nonatomic,assign) UIStatusBarStyle statusBarStyle;
/**状态栏是否隐藏，暂不支持*/


#pragma mark 授权页导航栏
/**导航栏背景颜色*/
@property (nonatomic,strong) UIColor *navBackColor;
/**导航栏标题文本内容*/
@property (nonatomic,strong) NSString *navText;
/**导航栏标题字体大小*/
@property (nonatomic,assign) int navTextSize;
/**导航栏标题字体是否加粗*/
@property (nonatomic,assign) BOOL navFontBold;
/**导航栏标题字体样式*/
@property (nonatomic,copy) NSString *navTextStyle;
/**导航栏标题字体颜色*/
@property (nonatomic,strong) UIColor *navTextColor;
/**导航栏标题是否隐藏*/
@property (nonatomic,assign) BOOL navIsHide;
/**返回按钮图片*/
@property (nonatomic,strong) UIImage *navReturnImg;

/**返回按钮图片上下位置*/
@property (nonatomic,assign) float navReturnOffsetX; //全屏时：按钮左侧距离屏幕左侧的偏移量 弹框时：按钮左侧距离弹框右侧的偏移量
@property (nonatomic,assign) float navReturnOffsetY;
/**返回按钮图片宽高*/
@property (nonatomic,assign) float navReturnWidth;
@property (nonatomic,assign) float navReturnHeight;
/**返回按钮图片缩放类型*/
@property (nonatomic,assign) UIViewContentMode navReturnContentMode;
/**返回按钮是否隐藏*/
@property (nonatomic,assign) BOOL navReturnHide;
/**导航栏上右上角按钮,暂不支持*/


#pragma mark 隐私协议导航栏
/**进入隐私协议导航栏背景颜色，不设置则与授权页一致*/
@property (nonatomic,strong) UIColor *navPruvacyBackColor;
/**进入隐私协议导航栏标题字体大小，不设置则与授权页一致*/
@property (nonatomic,assign) int navPruvacyTextSize;
/**进入隐私协议导航栏标题字体颜色，不设置则与授权页一致*/
@property (nonatomic,strong) UIColor *navPruvacyTextColor;
/**进入隐私协议导航栏返回图片，不设置则与授权页一致*/
@property (nonatomic,strong) UIImage *navPruvacyReturnImg;
/**进入隐私协议导航栏返回图片宽高*/ //移动不支持------------
//@property (nonatomic,assign) float navPruvacyReturnOffsetX;
//@property (nonatomic,assign) float navPruvacyReturnOffsetY;


#pragma mark LOGO
/**LOGO图片*/
@property (nonatomic,strong) UIImage *logoImg;

/**LOGO的上下左右位置*/
@property (nonatomic,assign) float logoOffsetX;
@property (nonatomic,assign) float logoOffsetY;
/**LOGO的宽高*/
@property (nonatomic,assign) float logoWidth;
@property (nonatomic,assign) float logoHeight;
/**LOGO是否隐藏*/
@property (nonatomic,assign) BOOL logoIsHiddle;
/**LOGO图片缩放类型*/
@property (nonatomic,assign) UIViewContentMode logoContentMode;


#pragma mark 手机掩码
/**手机号码字体颜色*/
@property (nonatomic,strong) UIColor *numberColor;
/**手机号码字体大小*/
@property (nonatomic,assign) int numberTextSize;
/**手机号码字体加粗，默认不加粗*/
@property (nonatomic,assign) BOOL numberTextBold;
/**手机号码MidX距离视图MidX轴的偏移*/ //注意不要超出屏幕，超出屏幕移动会错位
@property (nonatomic,assign) float numFieldOffsetX;
/**手机号码Y轴距离顶部偏移*/
@property (nonatomic,assign) float numFieldOffsetY;
/**手机号码文本字体样式，设置后字体加粗属性失效*/
@property (nonatomic,strong) NSString *numberTextStyle;
/**设置手机号码框的高度，暂不支持*/


#pragma mark 认证品牌
/**认证品牌字体大小*/
@property (nonatomic,assign) int brandLabelTextSize;
/**认证品牌字体颜色*/
@property (nonatomic,strong) UIColor *brandLabelTextColor;
/**认证品牌X轴距离屏幕左侧的偏移*/
@property (nonatomic,assign) float brandLabelOffsetX;
/**认证品牌Y轴距离顶部偏移*/
@property (nonatomic,assign) float brandLabelOffsetY;
/**认证品牌是否加粗*/
@property (nonatomic,assign) BOOL brandFontBold;
/**认证品牌文本字体样式，设置后字体加粗属性失效*/
@property (nonatomic,strong) NSString *brandTextStyle;
/**认证品牌文本自定义数组，固定顺序：移动，联通，电信*/
@property (nonatomic,strong) NSArray *brandTextArray;
/**认证品牌是否隐藏，暂不支持*/


#pragma mark 登录按钮
/**登录按钮文本内容*/
@property (nonatomic,strong) NSString *logBtnText;
/**登录按钮字体大小*/
@property (nonatomic,assign) int logBtnTextSize;
/**登录按钮文本颜色*/
@property (nonatomic,strong) UIColor *logBtnTextColor;
/**登录按钮的左右边距 注意:按钮呈现的宽度在竖屏时必须大于屏幕的一半,横屏时必须大于屏幕的三分之一,默认左右是20
 */
@property (nonatomic, assign) CGFloat logBtnOriginL;
@property (nonatomic, assign) CGFloat logBtnOriginR;
/**登录按钮宽高*/
//@property (nonatomic,assign) float logBtnWidth;
/**登录按钮高 注意：必须大于40*/
@property (nonatomic,assign) float logBtnHeight;
/**登录按钮Y轴位置*/
@property (nonatomic,assign) float logBtnOffsetY;
/**登录按钮圆角,通过圆角图片实现*/
//@property (nonatomic,assign) float logBtnCornerRadio;
/**登录按钮背景图片数组*/ //@[激活状态的图片,高亮状态的图片]
@property (nonatomic,strong) NSArray *logBtnImgs;
/**登录按钮字体是否加粗*/
@property (nonatomic,assign) BOOL logBtnFontBold;
/**登录按钮文本字体样式，设置后字体加粗属性失效*/
@property (nonatomic,strong) NSString *logBtnTextStyle;


#pragma mark 其他登录按钮
/**其他登录方式是否隐藏*/
@property (nonatomic,assign) BOOL otherWayLogBtnHidden;
/**其他登录方式文本内容*/
@property (nonatomic,strong) NSString *otherWayLogBtnText;
/**其他登录方式字体颜色*/
@property (nonatomic,strong) UIColor *otherWayLogBtnTextColor;
/**其他登录方式文本字体样式，默认 Helvetica */
@property (nonatomic,strong) NSString *otherWayLogBtnTextStyle;
/**其他登录方式字体大小*/
@property (nonatomic,assign) int otherWayLogBtnTextSize;
/**其他登录方式上下左右位置*/
@property (nonatomic,assign) float otherWayLogBtnOffsetX;
@property (nonatomic,assign) float otherWayLogBtnOffsetY;
/**其他登录方式宽高*/
@property (nonatomic,assign) float otherWayLogBtnOffWidth;
@property (nonatomic,assign) float otherWayLogBtnOffHeight;


#pragma mark 隐私协议
/**勾选框未勾选图片*/
@property (nonatomic,strong) UIImage *uncheckedImg;
/**勾选框已勾选图片*/
@property (nonatomic,strong) UIImage *checkedImg;
/**勾选框是否勾选*/
@property (nonatomic,assign) BOOL checkedStatus;
/**勾选框宽高*/
@property (nonatomic,assign) float checkedWH;
/**隐私条款左右边距*/
@property (nonatomic,assign) float pruvacyOffsetL;
@property (nonatomic,assign) float pruvacyOffsetR;
/**隐私条款顶部距离屏幕顶部偏移量，注意：若设置值超出屏幕边界会错位显示*/
@property (nonatomic,assign) float pruvacyOffsetY;

/**隐私条款字体大小*/
@property (nonatomic,assign) int pruvacyTextSize;
/**隐私条款最前面的文字*/
@property (nonatomic,strong) NSString *pruvacyBeforText;
/**第二个协议和第三个协议之间连接文字*/
@property (nonatomic,strong) NSString *pruvacyLinksText;
/**隐私条款最后面的文字*/
@property (nonatomic,strong) NSString *pruvacyAfterText;
/**自定义隐私条款标题和url数组*/
@property (nonatomic,strong) NSArray *pruvacyTitleAndUrlArr;
/**运营商默认隐私协议显示位置，第一个或最后一个*/
@property (nonatomic,assign) DefaultPruvacyPosition defaultPruvacyPosition;
/**隐私条款正常文字颜色*/
@property (nonatomic,strong) UIColor *norTruvacyTextColor;
/**隐私条款协议文字颜色*/
@property (nonatomic,strong) UIColor *pruTruvacyTextColor;
/**运营商隐私条款是否带书名号，默认不带书名号*/
@property (nonatomic,assign) BOOL pruvacyBookMark;
/**运营商隐私条款行距*/
@property (nonatomic,assign) float pruvacyLineSpacing;
/**运营商隐私条款文本对齐方式*/
@property (nonatomic,assign) NSTextAlignment pruvacyAlignment;
/**运营商隐私条款文本字体样式，设置后字体加粗属性失效*/
@property (nonatomic,strong) NSString *pruvacyTextStyle;
/**运营商隐私条款文本加粗*/
@property (nonatomic,assign) BOOL pruvacyFontBold;

/**隐私协议整体文案支持居中、居左设置，默认居左*/ //移动不支持----------------------------------------------------------
//@property (nonatomic,assign) NSTextAlignment pruvacyTextAlignment;
/****勾选框未勾选时，点击按钮时toast文本内容、字体大小、字体颜色、上下左右位置---------------------------------------------------*/
/**勾选框是否隐藏，暂不支持*/


#pragma mark 授权页面
/**授权页弹出和消失方向，仅支持全屏授权页*/
@property (nonatomic,assign) PresentDismissDirection presentDismissDirection;
/**背景颜色*/
@property (nonatomic,strong) UIColor *backgroundColor;
/**背景图片*/
@property (nonatomic,strong) UIImage *backgroundImage;
/**授权页面设置视频，暂不支持*/


#pragma mark 弹窗授权页
/**弹窗的宽高比例，底部弹窗时popupScaleW设置无效*/
@property (nonatomic,assign) float popupScaleW;
@property (nonatomic,assign) float popupScaleH;
/**弹窗的圆角，底部弹窗时只对弹窗顶部两个角生效*/
@property (nonatomic,assign) float popupCornerRadius;
/**是否底部弹窗，true 底部弹窗，false 居中弹窗**/
@property (nonatomic,assign) BOOL isBottom;
/**弹窗授权页背景透明度，仅支持居中弹窗*/
@property (nonatomic,assign) float popupAlpha;
/**弹窗授权页上下左右位置，暂不支持*/

#pragma mark 全屏页二次弹窗，仅在全屏时可用
/**全屏页面是否开启自定义二次弹窗*/
@property (nonatomic,assign) BOOL secondPOPUP;

#pragma mark 自定义控件
typedef void(^myCustomUIHandler)(UIView *customAreaView);
/**添加自定义控件的，三方入口*/
@property (nullable, nonatomic, copy) myCustomUIHandler customUIHandler;


@end

NS_ASSUME_NONNULL_END
