//
//  AbilityLoginManage.h
//  ability_login_ios_sdk
//
//  Created by mac2022 on 2022/7/18.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>

@class ClickLogConfig;

NS_ASSUME_NONNULL_BEGIN

@protocol abilityManageDelegate <NSObject>
@optional

//点击登录按钮
-(void)abilityLogclick;

//开启二次弹窗后，未勾选隐私协议时点击登录按钮的回调
-(void)secondPUPUPAbilityLogclick:(NSDictionary *)privacyAndUrl;

//点击其他登录方式
-(void)otherLogclick;

//点击了关闭按钮
-(void)closeButtonClick;

//隐私协议未选择
-(void)uncheckPrivacy;

//隐私协议框状态 
-(void)privacyAgreementBoxStatus:(BOOL) boxStatuss;

//授权页关闭完成
-(void)closeAuthViewControllerCompleted;

@end



@interface AbilityLoginManage : NSObject

+ (instancetype)instance;

//初始化方法1.0.3启用
-(void)initLogin:(NSString *)lxId secret:(NSString *)lxscecret isCompletion:(void(^)(NSDictionary *_Nonnull result))completion;

//预取号回调(timeout单位秒)
-(void)preLogin:(double)timeout isCompletion:(void(^)(NSDictionary *_Nonnull result))completion;

//登录获取token
-(void)loginToken:(nonnull UIViewController *)controller clickConfig:(nonnull ClickLogConfig *)config getTokenTimeout:(double)timeout isCompletion:(void(^)(NSDictionary *_Nonnull result))completion;

//关闭授权页面
-(void)closeAuthViewController;

//本机号码校验(timeout单位秒)
-(void)verificationPhoneNumber:(NSString *)phoneNumber verificatTimeout:(double)timeout isCompletion:(void(^)(NSDictionary *_Nonnull result))completion;

// 代理属性
@property (weak,nonatomic) id<abilityManageDelegate>delegate;

//获取sdk版本号
-(NSString *)getVersion;

//设置控制台日志输出开关
-(void)setPrintLoggerEnable:(BOOL)enable;

//判断设备移动数据网络是否开启
-(BOOL)checkDeviceCellularDataEnable;

//获取运营商类型
-(NSString *)getOperatorType;

//清除取号缓存
-(void)clearLoginCache;

//二次弹窗获取token，仅在开启二次弹窗后生效
-(void)secondPUPUPGetToken:(BOOL)status;

@end

NS_ASSUME_NONNULL_END
